SystemOrganization addCategory: #'XPF-CodeMarker'!
SystemOrganization addCategory: #'XPF-Tests-Models'!
SystemOrganization addCategory: #'XPF-Models'!
SystemOrganization addCategory: #'XPF-Seaside-Components'!

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 18:19'!!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint XPF).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:24'!!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:22'!!
toggleXPF

	self styler: XPFTextStyler new.
	self setTextInDefinitionPanel: target source.! !

!String methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/20/2009 17:17'!!
findAllStrings: aString
	"Returns a collection with all starting indices of the given string in me."
	
	|indices currentStartIndex|
	indices := Bag new.
	currentStartIndex := 1.
	
	[currentStartIndex := (self findString: aString startingAt: currentStartIndex) + 1.
		currentStartIndex > 1 
	] whileTrue: [indices add: currentStartIndex - 1].

	^indices.! !

TestCase subclass: #XPFTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:46'!!
isAbstract
 	^self name = #XPFTestCase! !

!XPFTestCase methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:34'!!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self
		assert: (aTargetObject perform: aSelector) == anObject
		! !

XPFTestCase subclass: #XPFUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFUserStoryTest methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:26'!!
setUp! !

!XPFUserStoryTest methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:39'!!
testAttributes
	| us |
	us := XPFUserStory new.
	self
		checkAccessor: #storyName on: us with: 'US + Tasks verwalten';
		checkAccessor: #storyDescription on: us with: 'Dinge tun und Sachen machen';
		checkAccessor: #storyPriority on: us with:'High';
		checkAccessor: #storyEstimate on: us  with: '10';
		checkAccessor: #storyActual on: us  with: '12'.
! !

OBTextMorphEditorWithShout subclass: #XPFEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFEditor class methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 12:29'!!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions at: ($q asInteger + 1) put: #markAsGood:.
	CmdActions at: ($r asInteger + 1) put: #markAsBad:.
	CmdActions at: ($t asInteger + 1) put: #markAsUnknown:.
	
"	evt commandKeyPressed & (evt keyCharacter == $q)
		ifTrue: [self paragraph setBackgroundForSelectionWith: Color green].
	evt commandKeyPressed & (evt keyCharacter == $r)
		ifTrue: [self paragraph setBackgroundForSelectionWith: Color red].
	evt commandKeyPressed & (evt keyCharacter == $t)
		ifTrue: [self paragraph setBackgroundForSelectionWith: Color lightGray]."
	
! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 13:34'!!
markAsGood: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color green.
	self userHasEdited.
	^ true
	"self halt."
	
"	evt commandKeyPressed & (evt keyCharacter == $q)
		ifTrue: [self paragraph setBackgroundForSelectionWith: Color green].
	evt commandKeyPressed & (evt keyCharacter == $r)
		ifTrue: [self paragraph setBackgroundForSelectionWith: Color red].
	evt commandKeyPressed & (evt keyCharacter == $t)
		ifTrue: [self paragraph setBackgroundForSelectionWith: Color lightGray]."
	
! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 11:05'!!
readKeyboard
	super readKeyboard.! !

!XPFEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 11:20'!!
setEmphasisHere
	emphasisHere := (paragraph text attributesAt: (self pointIndex - 1 max: 1) forStyle: paragraph textStyle)
					select: [:att | att mayBeExtended]! !

OBTextMorphWithShout subclass: #XPFTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 11:00'!!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XPFEditor! !

Object subclass: #XPFUserStory
	instanceVariableNames: 'storyName storyDescription storyPriority storyEstimate storyActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Models'!

XPFUserStory class
	instanceVariableNames: 'UserStories'!

XPFUserStory class
	instanceVariableNames: 'UserStories'!

!XPFUserStory class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:02'!!
allUserStories
	(UserStories isNil)
		ifTrue: [UserStories := OrderedCollection new].

	^UserStories! !

!XPFUserStory class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:02'!!
clearUserStories
	UserStories := nil.! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionActual
	^MANumberDescription new
		selectorAccessor: #storyActual;
		label: 'Actual';
		priority: 40;
		default: 0;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionDescription
	^MAMemoDescription new
		selectorAccessor: #storyDescription;
		label: 'Description';
		priority: 20;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionEstimate
	^MANumberDescription new
		selectorAccessor: #storyEstimate;
		label: 'Estimate';
		priority: 40;
		default: 0;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!!
descriptionName
	^MAStringDescription new
		selectorAccessor: #storyName;
		label: 'Name';
		priority: 10;
		default: 'New User Story';
		yourself! !

!XPFUserStory class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:07'!!
descriptionPriority
	^MANumberDescription new
		selectorAccessor: #storyPriority;
		label: 'Priority';
		priority: 30;
		default: 3;
		yourself! !

!XPFUserStory methodsFor: 'description' stamp: 'SR 1/22/2009 15:12'!!
descriptionReport
	^super description 
		select: [:each | #(storyName storyEstimate storyPriority) includes: each accessor selector]! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04'!!
storyActual
	^ storyActual! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04'!!
storyActual: anObject
	storyActual := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyDescription
	^ storyDescription! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyDescription: anObject
	storyDescription := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyEstimate
	^ storyEstimate! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyEstimate: anObject
	storyEstimate := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyName
	^ storyName! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyName: anObject
	storyName := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyPriority
	^ storyPriority! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!!
storyPriority: anObject
	storyPriority := anObject! !

WAComponent subclass: #XPFRootComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFRootComponent class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:26'!!
canBeRoot
	^true! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:44'!!
children
	^Array with: self report.! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:38'!!
createNewUserStory
	| us |
	us := self call: XPFUserStory new asComponent addValidatedForm.
	us ifNotNil: [XPFUserStory allUserStories add: us. self refreshReport].! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:20'!!
deleteUserStory: aUserStory

	(self confirm: 'Do you really want to delele...?') ifTrue: [
		XPFUserStory allUserStories remove: aUserStory.
		self refreshReport.
	].! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:03'!!
editUserStory: aUserStory
| us |

us := self call: (aUserStory description asComponentOn: aUserStory) addValidatedForm.
us ifNotNil: [self refreshReport].! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:33'!!
initialize
	super initialize.
	self initializeReport.! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:13'!!
initializeReport
	self report: (MAReport
 		rows: XPFUserStory allUserStories
 		description: XPFUserStory new descriptionReport).
		
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editUserStory: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteUserStory: text: 'delete';
			yourself).! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:39'!!
refreshReport
	self report rows: (XPFUserStory allUserStories).! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:06'!!
renderContentOn: html
	html div with: [
		html heading with:'User Stories'.
		
		html anchor callback: [self createNewUserStory]; with: 'Add User Story'.
		
		html div with: self report.
		]! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45'!!
report
	^ report! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45'!!
report: anObject
	report := anObject! !

WAComponent subclass: #XPFUserStoryComponent
	instanceVariableNames: 'userStory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFUserStoryComponent class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:28'!!
canBeRoot
	^true! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:33'!!
initialize
	super initialize.
	userStory := XPFUserStory new.! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:40'!!
renderContentOn: html
	html heading level:1; with:'User Story'.
	
	html paragraph with:'Name: '.
	html paragraph with:userStory storyName.
	html break.
	
	html paragraph with: 'Description: '.
	html paragraph with: userStory storyDescription.
	html break.

	html paragraph with: 'Proirity: '.
	html paragraph with: userStory storyPriority.
	html break.

	html paragraph with: 'Estimate: '.
	html paragraph with: userStory storyEstimate.
	html break.

	html paragraph with: 'Actual: '.
	html paragraph with: userStory storyActual.
	html break.	
! !

WAComponent subclass: #XPFUserStoryListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFUserStoryListComponent class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:47'!!
canBeRoot
	^true! !

!XPFUserStoryListComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:52'!!
renderContentOn: html
	html heading level1; with: 'All User Stories'.
	
	html unorderedList: [
		XPFUserStory allUserStories do: [ :story | 
			html listItem with: story storyName.
		]
	]! !

SHTextStylerST80 subclass: #XPFTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextStyler methodsFor: 'private' stamp: 'mt 1/23/2009 11:44'!!
privateFormat: aText
	^super privateFormat: aText.! !

!XPFTextStyler methodsFor: 'private' stamp: 'mt 1/23/2009 14:32'!!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns backupValues currentPos |
	backupRuns := OrderedCollection new.
	backupValues := OrderedCollection new.
	aText runs runsAndValuesDo: [:run :value | 
		backupRuns addLast: run.
		backupValues addLast: (value select: [:attribute | attribute isKindOf: XPFTextBackgroundColor ]).
	].
	
	super privateStyle: aText.
	
	currentPos := 1.
	backupRuns withIndexDo: [:run :index | 
		| currentValue |
		currentValue := backupValues at: index.
		currentValue ifNotEmpty: [
					aText addAttribute: currentValue first from: currentPos to: (currentPos + run - 1).
			].
		currentPos := currentPos + run.
	]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 16:27'!!
displayOn: aCanvas using: displayScanner at: somePosition 
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft) 
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: 
			[ :i | 
			line := lines at: i.
			self
				drawBackgroundOn: aCanvas
					at: line;
				displaySelectionInLine: line
					on: aCanvas.
			line first <= line last ifTrue: 
				[ leftInRun := displayScanner 
					displayLine: line
					offset: offset
					leftInRun: leftInRun ] ]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 16:27'!!
drawBackgroundOn: aCanvas at: line 
	| cb1 cb2 textLine bgAttr |
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: 
		[ :start :stop :attributes | 
		bgAttr := attributes 
			detect: [ :each | each isMemberOf: XPFTextBackgroundColor ]
			ifNone: [  ].
		bgAttr ifNotNil: 
			[ cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1).
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 right @ line bottom)
				color: bgAttr color ] ]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 17:24'!!
setBackgroundForSelectionWith: aColor
	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text addAttribute: (XPFTextBackgroundColor new color: aColor; yourself) from: selectionStart stringIndex to: selectionStop stringIndex - 1! !

!OBPluggableTextMorphWithShout methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 16:59'!!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XPFTextMorph! !

TextAttribute subclass: #XPFTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!!
= other 
	^ (other class == self class) 
		and: [other color = color]! !

!XPFTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:24'!!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XPFTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22'!!
color
	^ color! !

!XPFTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 17:51'!!
color: aColor
	color := aColor copy alpha: 0.4.! !

!XPFTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:26'!!
dominates: other
	^ other class == self class! !

!XPFTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!!
hash
	^ color hash! !

!XPFTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:25'!!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span style="background-color: #' , color printHtmlString , '">'! !

!XPFTextBackgroundColor methodsFor: 'printing' stamp: 'mt 1/22/2009 11:25'!!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!XPFTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:27'!!
writeScanOn: strm
	"Two formats.  c125000255 or cblue;"

	| nn str |
	strm nextPut: $h. "h ... highlight"
	(nn := color name) ifNotNil: [
		(self class respondsTo: nn) ifTrue: [
			^ strm nextPutAll: nn; nextPut: $;]].
	(Array with: color red with: color green with: color blue) do: [:float |
		str := '000', (float * 255) asInteger printString.
		strm nextPutAll: (str copyFrom: str size-2 to: str size)]! !
